_G.shuffle_play = _G.shuffle_play or {}
shuffle_play.mod_path = ModPath
shuffle_play.save_path = SavePath .. "shuffle_play.json"
shuffle_play.save_data = {}
shuffle_play.tracks = {
    "track_01", --Black Yellow Moebius
    "track_02", --Full Force Forward
    "track_03", --Fuse Box
    "track_04", --Razormind
    "track_05", --The Mark
    "track_06", --Calling All Units
    "track_07", --Tick Tock
    "track_08", --Time Window
    "track_09", --Armed To The Teeth
    "track_10", --Sirens In The Distance
    "track_11", --Wanted Dead Or Alive
    "track_12", --Death Wish
    "track_13", --Shadows And Trickery
    "track_14", --Ode To Greed
    "track_15", --And Now We Run
    "track_16", --Where's The Van
    "track_17", --Supersledge
    "track_18", --Evil Eye
    "track_19", --Hot Pursuit
    "track_20", --The Gauntlet
    "track_21", --Something Wicked This Way Comes
    "track_22", --Clowns Are Scary
    "track_23", --Ho Ho Ho
    "track_24", --Breach 2015
    "track_25", --Searchlights
    "track_26", --Kicking Ass and Taking Names
    "track_27", --Backstab
    "track_28", --Shoutout
    "track_29", --Dead Man's Hand
    "track_30", --Utter Chaos
    "track_31", --Gun Metal Grey 2015
    "track_35", --Crime Wave 2015
    "track_36", --Donacdum
    "track_37", --Locke and Load
    "track_38", --Drop Zone
    "track_39", --Pimped Out Getaway
    "track_40", --Screech
    "track_41", --Pounce
    "track_42", --Home Invasion 2016
    "track_43", --Three Way Deal 2016
    "track_44", --Sweat
    "track_45", --Storm Fuel Overload
    "track_46", --Driveshaft
    "track_47_gen", --The Take 2016
    "track_48", --Death Row
    "track_49", --Steel Wrapped Gift
    "track_50", --Break The Rules
    "track_51", --Bullet Rain
    "track_52", --Double Cross 2017
    "track_53", --Stone Cold 2017
    "track_54", --Left in the Cold
    "track_55", --I Will Give You My All 2017
    "track_56", --8bits Are Scary
    "track_57", --Troubles Always Inbound
    "track_58", --Mr Purple
    "track_59", --Blastaway
    "track_60", --Underground Lockdown
    "track_61", --Trick of the trade
    "track_62_lcv", --Le Castle Vania Confirmed Thrills
    "track_63", --Code Silver 2018
    "track_64_lcv", --Le Castle Vania Operation Black Light
    "track_32_lcv", --Le Castle Vania Use Of Force
    "track_33_lcv", --Le Castle Vania Fully Loaded Epic Win
    "track_34_lcv", --Le Castle Vania Infinite Ammo
    "track_65", --Dirt & Dust
    "track_66", --Blast Our Way Out
    "track_67", --Propulsive Force
    "track_68", --Bonebreaker
    "track_69", --Sucker Punch
    "track_70", --Cakewish
    "track_71", --Deadeye
    "track_72", --Gold Rush
    "track_73", --Dark Light Strike
    "track_74", --Payback Roulette
    "track_75", --Showdown Inferno
    "track_76", -- Trailblazers
    "track_77", -- Prime Attack
    "track_pth_01", --Gun Metal Grey
    "track_pth_02", --Double Cross
    "track_pth_03", --Home Invasion
    "track_pth_04", --Stone Cold
    "track_pth_05", --Three Way Deal
    "track_pth_06", --Phoney Money / The Take
    "track_pth_07", --Code Silver
    "track_pth_08", --Crime Wave
    "track_pth_09", --Breach of Security
}

local Setup_init_managers_original = Setup.init_managers

function Setup:init_managers(...)
    Setup_init_managers_original(self, ...)
    
    for _, track in ipairs(managers.music:jukebox_music_tracks()) do
        if CustomOST and CustomOST.track_manager:get_track(track) then
            shuffle_play.tracks[#shuffle_play.tracks+1] = track
        elseif tostring(shuffle_play.save_data.shuffle_play_beardlib_tracks_toggled) ~= "false" and BeardLib and BeardLib.MusicMods[track] then
            local tracks = BeardLib.MusicMods[track].tracks
            local track_index = managers.music:pick_track_index(tracks)
            local next_track = tracks and tracks[track_index]
            local source = next_track and (next_track.start_source or next_track.source)
            
			if source and source.module then
				source.module:LoadBuffers()
				shuffle_play.tracks[#shuffle_play.tracks+1] = track
			end
        end
    end
end

function shuffle_play.remove_track(track)
    for k, v in ipairs(shuffle_play.tracks) do
        if v == track then
            table.remove(shuffle_play.tracks, k)
        end
    end
end

function shuffle_play.remove_unwanted_tracks()
    if shuffle_play.save_data then
        for k, track_enabled in pairs(shuffle_play.save_data) do
			if not track_enabled then
				local track = k:gsub("shuffle_play_", "")
				track = track:gsub("_toggled", "")
				
                shuffle_play.remove_track(track)
            end
        end	
    end
	
    shuffle_play.remove_track(Global.music_manager.current_track)
end

function shuffle_play.set_random_track()
    if tostring(shuffle_play.save_data.shuffle_play_enable_toggled) == "false" then
        return
    end
    
    shuffle_play.tracks = managers.music:jukebox_music_tracks()
    shuffle_play.remove_unwanted_tracks()

    if #shuffle_play.tracks ~= 0 then
        local random_track = shuffle_play.tracks[math.random(#shuffle_play.tracks)]
        local event = Global.music_manager.current_event
        
        managers.music:track_listen_stop()
        
        if CustomOST and CustomOST.track_manager:get_track(random_track) then
            managers.music:track_listen_start(event, random_track)
        elseif BeardLib and BeardLib.MusicMods[random_track] then
            managers.music._current_custom_track = random_track
        else
            Global.music_manager.source:set_switch("music_randomizer", random_track)
        end
        
        managers.music:post_event(event)
        Global.music_manager.current_track = random_track
    end
end

function shuffle_play:save()
	local file = io.open(shuffle_play.save_path, "w+")

	if file then
		file:write(json.encode(shuffle_play.save_data))
		file:close()
	end
end

function shuffle_play:load()
	local file = io.open(shuffle_play.save_path, "r")
	
	if file then
		shuffle_play.save_data = json.decode(file:read("*all"))
    
		file:close()
    end
end